Parent: [175429] (diff)

Download this file

rclgnm    192 lines (158 with data), 4.9 kB

#!/bin/sh
# @(#$Id: rclsoff,v 1.12 2008-10-08 08:27:34 dockes Exp $  (C) 2004 J.F.Dockes
# Parts taken from Estraier:
#================================================================
# Estraier: a personal full-text search system
# Copyright (C) 2003-2004 Mikio Hirabayashi
#================================================================
#================================================================
# Extract text from a gnumeric spreadsheet
#================================================================

# set variables
LANG=C ; export LANG
LC_ALL=C ; export LC_ALL
progname="rclgnumeric"
filetype=gnumeric


#RECFILTCOMMONCODE
##############################################################################
# !! Leave the previous line unmodified!! Code imported from the
# recfiltcommon file

# Utility code common to all shell filters. This could be sourced at run
# time, but it's slightly more efficient to include the code in the
# filters at build time (with a sed script).

# Describe error in a way that can be interpreted by our caller
senderror()
{
    echo RECFILTERROR $*
    # Also alert on stderr just in case
    echo ":2:$progname::: $*" 1>&2
    exit 1
}

iscmd()
{
    cmd=$1
    case $cmd in
    */*)
	if test -x $cmd -a ! -d $cmd ; then return 0; else return 1; fi ;;
    *)
      oldifs=$IFS; IFS=":"; set -- $PATH; IFS=$oldifs
      for d in $*;do test -x $d/$cmd -a ! -d $d/$cmd && return 0;done
      return 1 ;;
    esac
}

checkcmds()
{
    for cmd in $*;do
      if iscmd $cmd 
      then 
        a=1
      else 
        senderror HELPERNOTFOUND $cmd
      fi
    done
}

# show help message
if test $# -ne 1 -o "$1" = "--help" 
then
  echo "Convert a $filetype file to HTML text for Recoll indexing."
  echo "Usage: $progname [infile]"
  exit 1
fi

infile="$1"

# check the input file existence (may be '-' for stdin)
if test "X$infile" != X- -a ! -f "$infile"
then
  senderror INPUTNOSUCHFILE "$infile"
fi

# protect access to our temp files and directories
umask 77

##############################################################################
# !! Leave the following line unmodified !
#ENDRECFILTCOMMONCODE

checkcmds xsltproc gunzip

# We need a temporary file
if test z"$RECOLL_TMPDIR" != z; then
   ttdir=$RECOLL_TMPDIR
elif test z"$TMPDIR" != z ; then
   ttdir=$TMPDIR
else
   ttdir=/tmp
fi
tmpfile=$ttdir/rclgnm.XXXXXX

tmpfile=`mktemp "$tmpfile"`
if [ $? -ne 0 ]; then
   senderror "$0: Can't create temp file, exiting..."
fi

cleanup()
{
    rm -f $tmpfile
}
    
trap cleanup EXIT HUP QUIT INT TERM

gunzip < $1 > $tmpfile || senderror "Cant uncompress input"
xsltproc --novalid --nonet - $tmpfile <<EOF
<?xml version="1.0"?>
<xsl:stylesheet version="1.0"
  xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
  xmlns:office="urn:oasis:names:tc:opendocument:xmlns:office:1.0" 
  xmlns:xlink="http://www.w3.org/1999/xlink" 
  xmlns:dc="http://purl.org/dc/elements/1.1/" 
  xmlns:meta="urn:oasis:names:tc:opendocument:xmlns:meta:1.0" 
  xmlns:ooo="http://openoffice.org/2004/office"
  xmlns:gnm="http://www.gnumeric.org/v10.dtd"

  exclude-result-prefixes="office xlink meta ooo dc"
  >

<xsl:output method="html" encoding="UTF-8"/>

<xsl:template match="/">
<html>
  <head>
   <meta http-equiv="Content-Type" content="text/html; charset=UTF-8"/>
   <xsl:apply-templates select="//office:document-meta/office:meta"/>
  </head>

  <body>
    <xsl:apply-templates select="//gnm:Cells"/>
    <xsl:apply-templates select="//gnm:Objects"/>
  </body>
</html>
</xsl:template>

<xsl:template match="//dc:date">
   <meta>
     <xsl:attribute name="name">date</xsl:attribute>
     <xsl:attribute name="content"><xsl:value-of select="."/></xsl:attribute>
   </meta>
</xsl:template>

<xsl:template match="//dc:description">
  <meta>
    <xsl:attribute name="name">abstract</xsl:attribute>
    <xsl:attribute name="content"><xsl:value-of select="."/></xsl:attribute>
  </meta>
</xsl:template>

<xsl:template match="//meta:keyword">
  <meta>
    <xsl:attribute name="name">keywords</xsl:attribute>
    <xsl:attribute name="content"><xsl:value-of select="."/></xsl:attribute>
  </meta>
</xsl:template>

<xsl:template match="//dc:subject">
  <meta>
    <xsl:attribute name="name">keywords</xsl:attribute>
    <xsl:attribute name="content"><xsl:value-of select="."/></xsl:attribute>
  </meta>
</xsl:template>

<xsl:template match="//dc:title">
  <title> <xsl:value-of select="."/> </title>
</xsl:template>

<xsl:template match="//meta:initial-creator">
  <meta>
    <xsl:attribute name="name">author</xsl:attribute>
    <xsl:attribute name="content"><xsl:value-of select="."/></xsl:attribute>
  </meta>
</xsl:template>

<xsl:template match="office:meta/*"/>

<xsl:template match="gnm:Cell">
  <p><xsl:value-of select="."/></p>
</xsl:template>

<xsl:template match="gnm:CellComment">
  <blockquote><xsl:value-of select="@Text"/></blockquote>
</xsl:template>

</xsl:stylesheet>
EOF